// Blend Morph Coder
// a tool for making 2D animated head turns by
// Steve Tiffany, 2012, using a lot of code by 
// Jo Wood  and 
// Clipboard class for Processing
// by seltar, modified by adamohern

// Please read the tutorial, but basically:
// Click to add a point, and shift-drag mouse to move a point.
// (After first screen, just drag points with mouse.)
// Keys 1-4 change background image.
// Key 5 to test blend morph.
// Key 'N' to start a new shape.
// Key 'C' to copy the code to the Clipboard for pasting.
// 'Delete' key deletes last point.

int numShapes; // number of shapes
int[] numVerts = new int[20]; // number of vertices per shape
PVector[] coords = new PVector[500]; // all vertices for all shapes, left
PVector[] coords2 = new PVector[500]; // ", looking right
PVector[] coords3 = new PVector[500]; // ", " up
PVector[] coords4 = new PVector[500]; // ", " down
color[] dotColors = {#FF0000,#00E628,#3567FA,#FC9800,#9B00FC,
                     #BC8F13,#FF6FD4,#25C9BF,#A1A1A1};
int totalVerts = 0; 
boolean isShiftDown; 
PVector pClosest;
PImage b1, b2, b3, b4;
int bnum = 1;
int x, y;
// for Clipboard class...v 0115AO...
import java.awt.datatransfer.*;
import java.awt.Toolkit; 
ClipHelper cp = new ClipHelper();

void setup() {
  size(400, 400);
  smooth();
  numShapes = 1; // so ready to add vertices to first shape
  b1 = loadImage("1.png"); 
  b2 = loadImage("2.png"); 
  b3 = loadImage("3.png"); 
  b4 = loadImage("4.png"); 
}

void draw() { 
  switch(bnum) {
    case 1: image(b1,0,0); break; 
    case 2: image(b2,0,0); break; 
    case 3: image(b3,0,0); break; 
    case 4: image(b4,0,0); break;
    case 5: background(255); break;
  }
  // background(255); // if drawing freehand, hide images
  // line(0,height/2,width,height/2); line(width/2,0,width/2,height);
  x = mouseX; y = mouseY; 
  fill(0); text(bnum,width-10,10);
  fill(50,0,0,20); // alpha 20 is almost transparent

  // Draw the boundary using Processing's curve method.
  switch(bnum) {
    case 1:
      int coordCounter = 0;
      for (int i=0; i<numShapes; i++) { 
        if (numVerts[i] >= 3)
        {
          beginShape();
          int startcc = coordCounter;
          for(int j=0; j < numVerts[i]; j++) {
            PVector p = coords[coordCounter];
            coordCounter++;
            curveVertex(p.x,p.y);
          } // overlap with first 3 points to close boundary:
          for(int k=startcc; k<(startcc+3); k++) {
            PVector p = coords[k];
            curveVertex(p.x,p.y);
          }
          endShape();
        }
      }
      break;
    case 2:
      coordCounter = 0;
      for (int i=0; i<numShapes; i++) { 
        if (numVerts[i] >= 3)
        {
          beginShape();
          int startcc = coordCounter;
          for(int j=0; j < numVerts[i]; j++) {
            PVector p = coords2[coordCounter];
            coordCounter++;
            curveVertex(p.x,p.y);
          } 
          for(int k=startcc; k<(startcc+3); k++) {
            PVector p = coords2[k];
            curveVertex(p.x,p.y);
          }
          endShape();
        }
      }
      break;
    case 3:
      coordCounter = 0;
      for (int i=0; i<numShapes; i++) { 
        if (numVerts[i] >= 3)
        {
          beginShape();
          int startcc = coordCounter;
          for(int j=0; j < numVerts[i]; j++) {
            PVector p = coords3[coordCounter];
            coordCounter++;
            curveVertex(p.x,p.y);
          } 
          for(int k=startcc; k<(startcc+3); k++) {
            PVector p = coords3[k];
            curveVertex(p.x,p.y);
          }
          endShape();
        }
      }
      break;
    case 4:
      coordCounter = 0;
      for (int i=0; i<numShapes; i++) { 
        if (numVerts[i] >= 3)
        {
          beginShape();
          int startcc = coordCounter;
          for(int j=0; j < numVerts[i]; j++) {
            PVector p = coords4[coordCounter];
            coordCounter++;
            curveVertex(p.x,p.y);
          } 
          for(int k=startcc; k<(startcc+3); k++) {
            PVector p = coords4[k];
            curveVertex(p.x,p.y);
          }
          endShape();
        }
      }
      break;
   }
  // Draw the original points.
  strokeWeight(6);
  int coordCounter = 0;
  int colorCounter = 0;
  switch(bnum) {
    case 1:
      for (int i=0; i<numShapes; i++) {
        stroke(0); // first dot is black 
        beginShape(POINTS);
        int startcc = coordCounter;
        for(int j=0; j < numVerts[i]; j++) {
          PVector p = coords[coordCounter];
          coordCounter++;
          vertex(p.x,p.y); 
          stroke(dotColors[colorCounter]);
        }
        endShape();
        colorCounter++; 
        if (colorCounter==dotColors.length) {colorCounter = 0;}
      }
      break;
    case 2:
      for (int i=0; i<numShapes; i++) { 
        stroke(0); 
        beginShape(POINTS);
        int startcc = coordCounter;
        for(int j=0; j < numVerts[i]; j++) {
          PVector p = coords2[coordCounter];
          coordCounter++;
          vertex(p.x,p.y); stroke(255,0,0);
          stroke(dotColors[colorCounter]);
        }
        endShape();
        colorCounter++; 
        if (colorCounter==dotColors.length) {colorCounter = 0;}
      }
      break;
    case 3:
      for (int i=0; i<numShapes; i++) { 
        stroke(0); 
        beginShape(POINTS);
        int startcc = coordCounter;
        for(int j=0; j < numVerts[i]; j++) {
          PVector p = coords3[coordCounter];
          coordCounter++;
          vertex(p.x,p.y); stroke(255,0,0);
          stroke(dotColors[colorCounter]);
        }
        endShape();
        colorCounter++; 
        if (colorCounter==dotColors.length) {colorCounter = 0;}
      }
      break;
    case 4:
      for (int i=0; i<numShapes; i++) { 
        stroke(0); 
        beginShape(POINTS);
        int startcc = coordCounter;
        for(int j=0; j < numVerts[i]; j++) {
          PVector p = coords4[coordCounter];
          coordCounter++;
          vertex(p.x,p.y); stroke(255,0,0);
          stroke(dotColors[colorCounter]);
        }
        endShape();
        colorCounter++; 
        if (colorCounter==dotColors.length) {colorCounter = 0;}
      }
      break;
    case 5: // mouse movements test blend morph
      coordCounter = 0;
      stroke(0); strokeWeight(1);
      for (int i=0; i<numShapes; i++) { 
        if (numVerts[i] >= 3)
        {
          beginShape();
          int startcc = coordCounter;
          int[] xy = new int[12];
          for(int j=0; j < numVerts[i]; j++) {
            PVector p = coords[coordCounter];
            PVector p2 = coords2[coordCounter];
            PVector p3 = coords3[coordCounter];
            PVector p4 = coords4[coordCounter];
            coordCounter++;
            curveVertex(map(x,0,width,p.x,p2.x), map(y,0,height,p3.y,p4.y));
            if (j==0) {xy[0]=int(p.x); xy[1]=int(p2.x); xy[2]=int(p3.y); xy[3]=int(p4.y);} 
            if (j==1) {xy[4]=int(p.x); xy[5]=int(p2.x); xy[6]=int(p3.y); xy[7]=int(p4.y);} 
            if (j==2) {xy[8]=int(p.x); xy[9]=int(p2.x); xy[10]=int(p3.y); xy[11]=int(p4.y);} 
          } // overlap with 1st 3 points to close boundary:
          curveVertex(map(x,0,width,xy[0],xy[1]), map(y,0,height,xy[2],xy[3]));
          curveVertex(map(x,0,width,xy[4],xy[5]), map(y,0,height,xy[6],xy[7]));
          curveVertex(map(x,0,width,xy[8],xy[9]), map(y,0,height,xy[10],xy[11]));
          }
          endShape();
        }
        break;
      }
      stroke(0); strokeWeight(1);
}

void mouseClicked() { // the only place vertices are added
  if (!isShiftDown) {
    coords[totalVerts] = new PVector(mouseX,mouseY);
    coords2[totalVerts] = new PVector(mouseX,mouseY);
    coords3[totalVerts] = new PVector(mouseX,mouseY);
    coords4[totalVerts] = new PVector(mouseX,mouseY);
    totalVerts++;
    // make coords array larger if necessary
    if (totalVerts==coords.length) { 
      coords = (PVector[]) expand(coords);
      coords2 = (PVector[]) expand(coords2);
      coords3 = (PVector[]) expand(coords3);
      coords4 = (PVector[]) expand(coords4);
      println("coords.length = " + coords.length);
    }
    // make numVerts array larger if necessary
    int n = numVerts[numShapes-1]; 
    n++;
    if (n==numVerts.length) {
      numVerts = expand(numVerts);
      println("numVerts.length = " + numVerts.length);
    }
    numVerts[numShapes-1] = n; 
  }
}

void mousePressed()
{
  if (isShiftDown)
  {
    float dMin = Float.MAX_VALUE;
    pClosest = null;
    PVector mouse = new PVector(mouseX,mouseY);
    switch(bnum) {
      case 1:
        for (int i=0; i < totalVerts; i++)
        {
          PVector p = coords[i];   
          float d = mouse.dist(p);
          if (d < dMin)
          {
            dMin = d;
            if (dMin < 20)
            {
              pClosest = p;
            }
          }
        }
        break;
      case 2:
        for (int i=0; i < totalVerts; i++)
        {
          PVector p = coords2[i];   
          float d = mouse.dist(p);
          if (d < dMin)
          {
            dMin = d;
            if (dMin < 20)
            {
              pClosest = p;
            }
          }
        }
        break;
      case 3:
        for (int i=0; i < totalVerts; i++)
        {
          PVector p = coords3[i];   
          float d = mouse.dist(p);
          if (d < dMin)
          {
            dMin = d;
            if (dMin < 20)
            {
              pClosest = p;
            }
          }
        }
        break;
      case 4:
        for (int i=0; i < totalVerts; i++)
        {
          PVector p = coords4[i];   
          float d = mouse.dist(p);
          if (d < dMin)
          {
            dMin = d;
            if (dMin < 20)
            {
              pClosest = p;
            }
          }
        }
        break;
    }
  } 
}

void mouseDragged() {
  if ((pClosest != null) && (isShiftDown) && (bnum<5))
  {
     pClosest.x = mouseX;
     pClosest.y = mouseY; 
  }
}

void keyPressed() {
  if ((key==CODED) && (keyCode == SHIFT))
  {
    isShiftDown = true;
  }
}

void keyReleased()
{
  if ((key==CODED) && (keyCode == SHIFT))
  {
    isShiftDown = false;
  }
  switch(key) {
    case 49: // 1 key
      bnum = 1; if (totalVerts==0) {isShiftDown = false;} 
      else {isShiftDown = true;} 
      break;
    case 50: bnum = 2; isShiftDown = true; break; // 2 key
    case 51: bnum = 3; isShiftDown = true; break; // 3 key
    case 52: bnum = 4; isShiftDown = true; break; // 4 key
    case 53: bnum = 5; isShiftDown = true; break; // 5 key
    case 110: // N key for New shape
      numShapes++;
      bnum = 1; isShiftDown = false;
      println("New Shape: " + numShapes);
      break;
    case 115: // s key = Save code
    case 99:  // c key = Copy code
      if (totalVerts<3) {break;} // nothing to draw!
      int coordCounter = 0;
      String megacodeline = "";
      for (int i=0; i<numShapes; i++) { 
        if (numVerts[i] >= 3)
        {
          megacodeline = megacodeline + "  beginShape(); // \n";
          String codeline = "";
          String codeline1 = "";
          String codeline2 = "";
          String codeline3 = "";
          int startcc = coordCounter;
          for(int j=0; j < numVerts[i]; j++) {
            PVector p = coords[coordCounter];
            //coordCounter++;
            codeline = "  curveVertex(map(x,0,width," + int(p.x) + ",";
            p = coords2[coordCounter];
            codeline = codeline + int(p.x) + "), map(y,0,height,";
            p = coords3[coordCounter];
            codeline = codeline + int(p.y) + ",";
            p = coords4[coordCounter];
            codeline = codeline + int(p.y) + "));\n";
            coordCounter++;
            megacodeline = megacodeline + codeline;
            if (j==0) {codeline1 = codeline;}
            if (j==1) {codeline2 = codeline;}
            if (j==2) {codeline3 = codeline;}
          }
          megacodeline = megacodeline + codeline1; 
          megacodeline = megacodeline + codeline2;
          megacodeline = megacodeline + codeline3;
          megacodeline = megacodeline + "  endShape();\n\n";
        }
      }
      cp.copyString(megacodeline);
      println("Code can now be pasted into your program.");
      break;
    case 127: // Delete key to delete last point
      int n = numVerts[numShapes-1];
      n--;
      if (n<0) {
        n = 0; numShapes--; if (numShapes<1) {numShapes = 1;}
      } else {
        numVerts[numShapes-1] = n;
        totalVerts--; if (totalVerts<0) {totalVerts = 0;}
      }
  }
}

// CLIPHELPER OBJECT CLASS:
// only works with programs. applets require signing
class ClipHelper {
  Clipboard clipboard;
  
  ClipHelper() {
    getClipboard();  
  }
  
  void getClipboard () {
    // this is our simple thread that grabs the clipboard
    Thread clipThread = new Thread() {
	public void run() {
	  clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
	}
    };
  
    // start the thread as a daemon thread and wait for it to die
    if (clipboard == null) {
	try {
	  clipThread.setDaemon(true);
	  clipThread.start();
	  clipThread.join();
	}  
	catch (Exception e) {}
    }
  }
  
  void copyString (String data) {
    copyTransferableObject(new StringSelection(data));
  }
  
  void copyTransferableObject (Transferable contents) {
    getClipboard();
    clipboard.setContents(contents, null);
  }
  
//  String pasteString () {
//    String data = null;
//    try {
//	data = (String)pasteObject(DataFlavor.stringFlavor);
//    }  
//    catch (Exception e) {
//	System.err.println("Error getting String from clipboard: " + e);
//    }
//    return data;
//  }
//  
//  Object pasteObject (DataFlavor flavor)  
//  throws UnsupportedFlavorException, IOException
//  {
//    Object obj = null;
//    getClipboard();
//    
//    Transferable content = clipboard.getContents(null);
//    if (content != null)
//    obj = content.getTransferData(flavor);
//    
//    return obj;
//  }
}

